unit FormFM;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Dialogs, FMX.Layouts, FMX.Objects,
  FMX.Effects, Data.Bind.EngExt, Fmx.Bind.DBEngExt, System.Rtti,
  System.Bindings.Outputs, Data.Bind.Components;

type
  TFormMainFM = class(TForm)
    imgCentral: TImage;
    btnCerrar: TButton;
    TimerRot: TTimer;
    ReflectionEffect: TReflectionEffect;
    StyleBook1: TStyleBook;
    OpenDialog1: TOpenDialog;
    Button1: TButton;
    ProgressBar1: TProgressBar;
    BindingsList1: TBindingsList;
    BindExprItems1: TBindExprItems;
    procedure btnCerrarClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TimerRotTimer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  published
    // Mtodo de clase para crear y visualizar
    class procedure ExecForm();
    class procedure Start();
    class procedure Stop();
  end;

// Prototipos de Start y Finish del mdulo
procedure Start_Pack();
procedure Finish_Pack();

var
  FormMainFM: TFormMainFM;

implementation

{$R *.fmx}


procedure TFormMainFM.btnCerrarClick(Sender: TObject);
begin
  Self.Close;
end;

procedure TFormMainFM.FormClose(Sender: TObject; var Action: TCloseAction);
begin
//  Action := System.UITypes.caFree;
end;



procedure TFormMainFM.FormCreate(Sender: TObject);
var
  Str:String;
begin
  Str := IncludeTrailingBackslash(ExtractFilePath(ParamStr(0))) + 'dark.style';
  if FileExists(Str) then begin
    // Aplicar
    Application.StyleFileName := Str;
  end;
end;

class procedure TFormMainFM.Start;
begin
  FormMainFM.TimerRot.Enabled := True;
end;

class procedure TFormMainFM.Stop;
begin
  FormMainFM.TimerRot.Enabled := False;
end;

class procedure TFormMainFM.ExecForm();
begin
  FormMainFM :=  nil;
  FormMainFM := TFormMainFM.Create(nil);
  FormMainFM.Show;
end;


procedure TFormMainFM.TimerRotTimer(Sender: TObject);
begin
  imgCentral.RotationAngle := (imgCentral.RotationAngle + 10);
end;


procedure Start_Pack();
begin
  // Crear el formulario
  FormMainFM := TFormMainFM.Create(nil);
  FormMainFM.Show;
end;

procedure Finish_Pack();
begin
  // Liberar el form
  FormMainFM.Free;
end;


//=========================================================================
// I N I T I A L I Z A T I O N
//=========================================================================
initialization
//  Start_Pack();
  RegisterClass(TFormMainFM);


//=========================================================================
// F I N A L I Z A T I O N
//=========================================================================
finalization
//  Finish_Pack();
  UnregisterClass(TFormMainFM);




end.
