unit UMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants,
  System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls,
  Vcl.ExtCtrls, Vcl.ComCtrls;

type

  //: Tipo para ejecutar un mtodo de clase RunMultiSelecc
  TExecuteExecForm = procedure() of object;

  TForm3 = class(TForm)
    Edit1: TEdit;
    Label1: TLabel;
    Button1: TButton;
    Button2: TButton;
    Memo1: TMemo;
    btnStart: TButton;
    btnStop: TButton;
    Button4: TButton;
    ProgressBar1: TProgressBar;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure btnStartClick(Sender: TObject);
    procedure btnStopClick(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    F:TForm;
    Routine: TMethod;
    FormClass:TFormClass;

    procedure DoRunMethod(MethodName:string);
  public
    { Public declarations }

  end;

var
  Form3: TForm3;

implementation

{$R *.dfm}

uses
  FMX.Forms;

procedure TForm3.btnStartClick(Sender: TObject);
begin

  DoRunMethod('Start');

end;

procedure TForm3.btnStopClick(Sender: TObject);
begin
  DoRunMethod('Stop');
end;

procedure TForm3.Button1Click(Sender: TObject);
var
  H: Thandle;
  res:integer;
  fName:string;
  AClass:TPersistentClass;
begin

  fName := Edit1.Text;

  // existe el fichero?
  if not FileExists(fName) then begin
    Memo1.Lines.Add('Error al cargar el package; No se encuentra el fichero: ' + fName);
    Exit;
  end;

  Memo1.Lines.Add('El fichero de package existe en disco');
  Memo1.Lines.Add('Se va a cargar el package...');

  // Cargando
  H := LoadPackage(Edit1.Text);

  // Cargado correctamente?
  if (H > 0) then begin
    Memo1.Lines.Add('El package se ha cargado correctamente (' + IntToStr(h) + ')');

    // Acceder a la clase del form
    AClass := GetClass('TFormMainFM');
    // encontrada
    if Assigned(AClass) then begin
      Memo1.Lines.Add('AClass<>nil;   Se ha encontrado la referencia al formulario');
      // Cear el form
      F := TFormClass(AClass).Create(nil);
      Memo1.Lines.Add('Creado el form correctamente; Accediendo a los mtodos');

      // Acceder al mtodo
      Routine.Data := Pointer(F);
      // Ejecutar al cdigo
      Routine.Code := (F).MethodAddress('ExecForm');

      // No ha encontrado el cdigo de la rutina...
      if (Routine.Code <> nil) then begin
        Memo1.Lines.Add('Se ha encontrado el punto de entrada del mtodo <ExecForm>');
        Memo1.Lines.Add('Se va a ejecutar el mtodo...');
        // Ejecutarlo
        TExecuteExecForm(Routine);
        Memo1.Lines.Add('Ejecutado OK. Form visible');

        btnStart.Visible := True;
        btnStop.Visible := True;
        Button1.Enabled := False;
      end
      else  begin
        Memo1.Lines.Add('No se ha encontrado el punto de entrada del mtodo <ExecForm>');
      end;
    end
    else begin
      Memo1.Lines.Add('Error, no se ha encontrado la clase <TFormMainFM> en el package ' + fName);
    end;
  end
  else begin
    Memo1.Lines.Add('Error, no se ha cargado el packae');
  end;

  button4.Enabled := False;
end;

procedure TForm3.Button2Click(Sender: TObject);
begin
  Self.Close;
end;



procedure TForm3.Button3Click(Sender: TObject);
begin
//  FormMainFM := TFormMainFM.Create(nil);
//  FormMainFM.BorderStyle := TFmxFormBorderStyle(bsNone);
//  FormMainFM.Show;
//  FormMainFM.TimerRot.Enabled := not FormMainFM.TimerRot.Enabled;
end;

procedure TForm3.Button4Click(Sender: TObject);
var
  H: Thandle;
  fName:String;
begin
  // Nombre del package
  fName := Edit1.Text;
  // existe el fichero?
  if not FileExists(fName) then begin
    Memo1.Lines.Add('Error al cargar el package; No se encuentra el fichero: ' + fName);
    Exit;
  end;

  Memo1.Lines.Add('Se va a cargar el package...');
  // Cargando
  H := LoadPackage(Edit1.Text);
  // Cargado correctamente?
  if (H > 0) then begin
    Memo1.Lines.Add('El package se ha cargado correctamente (' + IntToStr(h) + ')');
  end
  else begin
    Memo1.Lines.Add('Error, no se ha cargado el packae');
  end;

  button1.Enabled := False;
end;

procedure TForm3.DoRunMethod(MethodName: string);
begin
  // Acceder al mtodo
  Routine.Data := Pointer(F);
  // Ejecutar al cdigo
  Routine.Code := (F).MethodAddress(MethodName);
  // No ha encontrado el cdigo de la rutina...
  if (Routine.Code <> nil) then begin
    Memo1.Lines.Add(Format('Se ha encontrado el punto de entrada del mtodo <%s>', [MethodName]));
    Memo1.Lines.Add('Se va a ejecutar el mtodo...');
    // Ejecutarlo
    TExecuteExecForm(Routine);
    Memo1.Lines.Add('Ejecutado.');
//    btnStart.Enabled := not btnStart.Enabled;
//    btnStop.Enabled := not btnStop.Enabled;

    btnStart.Invalidate;
    btnStop.Invalidate;
  end
end;



procedure TForm3.FormShow(Sender: TObject);
begin
  Edit1.Text := IncludeTrailingBackslash(ExtractFilePath(ParamStr(0))) + 'FMPack.bpl';
end;

end.
